//--------------------------------------------------------------------------//
// Title:       Camera.v                                                //
// Rev:         Rev 0                                                       //
// Created:     June 13, 2016                                               //
//--------------------------------------------------------------------------//
// Description: Cyclone V SX SoC pinout and IO Standard example design      //              					                        //
//--------------------------------------------------------------------------//
// Revision History:                                                        //
// Rev 0:       1st cut                                                      //
//----------------------------------------------------------------------------
//------ 1 ------- 2 ------- 3 ------- 4 ------- 5 ------- 6 ------- 7 ------7
//------ 0 ------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------8
//----------------------------------------------------------------------------
//Copyright 2012 Altera Corporation. All rights reserved.  Altera products  
//are protected under numerous U.S. and foreign patents, maskwork rights,     
//copyrights and other intellectual property laws.                            
//                                                                            
//This reference design file, and your use thereof, is subject to and         
//governed by the terms and conditions of the applicable Altera Reference     
//Design License Agreement.  By using this reference design file, you         
//indicate your acceptance of such terms and conditions between you and       
//Altera Corporation.  In the event that you do not agree with such terms and 
//conditions, you may not use the reference design file. Please promptly      
//destroy any copies you have made.                                           
//                                                                            
//This reference design file being provided on an "as-is" basis and as an                                             
//accommodation and therefore all warranties, representations or guarantees   
//of any kind (whether express, implied or statutory) including, without      
//limitation, warranties of merchantability, non-infringement, or fitness for 
//a particular purpose, are specifically disclaimed.  By making this          
//reference design file available, Altera expressly does not recommend,       
//suggest or require that this reference design file be used in combination   
//with any other product not provided by Altera.                              
//                                                                            



//`define		HPS
`define	DDR3_FPGA
//`define	DDR3_HPS
//`define	I2C_FPGA
//`define	MAX_FPGA

//`define	HSMA_XCVR      
//`define	HSMA_LVDS
//`define	HSMA_PARALLEL 
//`define	PCIE_XCVR
//`define	SDI_XCVR

module Camera (
//--------------------------------------------------------------------------//
/*
//User-IO------------------------------//X pins  //--------------------------
	output [3:0]   user_led_fpga,       
	
//GPLL-CLK-----------------------------//X pins
   input          clk_100m_fpga,       //2.5V    //100 MHz (2nd copy to max)
   input          clk_50m_fpga,        //2.5V    //50MHz (2nd copy to max) 

	input          clk_top1,            //2.5V    //156.25 MHz adjustable
   input          clk_bot1,            //1.5V    //100 MHz ajustable

	  output         ddr3_fpga_csn,       //SSTL15  //Chip Select
	input          cpu_resetn          //2.5V    //NIOS CPU Reset Pushbutton
*/
//--------------------------------------------------------------------------//
//////////////////// Hard Processor System (HPS) pins ////////////////////////
//--------------------------------------------------------------------------//

`ifdef	HPS
//HPS-CLK-INPUT------------------------//2 pins   //--------------------------
   //input          clk_osc1,            //3.3V     //Not for instantiation
   //input          clk_osc2,            //3.3V     //Not for instantiation

//HPS-Reset----------------------------//2 pins  //--------------------------
   //inout          mictor_rstn,         //3.3V    //Cold Reset 
   //input          hps_resetn,          //3.3V    //Warm Reset 

//HPS-User-IO--------------------------//X pins  //--------------------------
   //input  [3:0]   user_dipsw_hps,      //1.5V
   //output [3:0]   user_led_hps,        //3.3V
   //input  [1:0]   user_pb_hps,         //1.5V

//HPS-UART----------------------------//2 pins   //--------------------------
   input          uart_rx,            //3.3V LV  //UART Receive
   output         uart_tx,            //3.3V     //UART Transmit


//HPS-I2C------------------------------//2 pins  //--------------------------
	inout          i2c_scl_hps,         //3.3V    //HPS I2C Clock output
	inout          i2c_sda_hps,         //3.3V    //HPS I2C Data Input/Output
	
//HPS-SPI-Bus--------------------------//4 pins  //--------------------------
	output         spi_csn,             //3.3V    //Slave Sel 0 - LTC Analog
	input          spi_miso,            //3.3V    //Master Input
	output         spi_mosi,            //3.3V    //Master Output 
	output         spi_sck,             //3.3V    //Clock Output 

//HPS-QSPI-Flash-----------------------//6 pins  //--------------------------
	output         qspi_clk,            //3.3V    //Clock
	inout [3:0]    qspi_io,             //3.3V    //Data
	output         qspi_ss0,            //3.3V    //Select
	
//HPS-SD-Card-Flash--------------------//7 pins  //--------------------------
   output         sd_clk,              //3.3V    //
	inout          sd_cmd,              //3.3V    //
	output         sd_pwren,            //3.3V    //
   //inout  [3:0]   sd_dat,              //3.3V    //???????????????  should only be (3:0) ????????
   inout  [7:0]   sd_dat,              //3.3V    //???????????????  should only be (3:0) ????????

//HPS-USB-OTG-------------------------//19 pins  //--------------------------
	input          usb_clk,            //3.3V     //Clock
	inout  [7:0]   usb_data,           //3.3V     //
	input          usb_nxt,            //3.3V     //
	input          usb_dir,            //3.3V     //
	output         usb_stp,            //3.3V     //
	input          usb_empty,  
	input          usb_full,    
	output         usb_oen,    
	output         usb_rdn,       
	output         usb_resetn,
	output         usb_scl,       
	inout          usb_sda,       
	output         usb_wrn,
	

//HPS-Ethernet----10/100/1000----------//14 pins //--------------------------
	output         enet_hps_gtx_clk,    //3.3V    //Gb Ethernet Clock
	//input			   enet_hps_intn,       //3.3V    //Placed on HPS GPIO
	output         enet_hps_mdc,        //3.3V    //MDIO Clock (TR=0)
	inout          enet_hps_mdio,       //3.3V    //MDIO Data (TR=0)
	input			   enet_hps_rx_clk,     //3.3V    //Receive Data
	input			   enet_hps_rx_dv,      //3.3V    //Receive Data Valid / Cont
	input	[3:0]	   enet_hps_rxd,        //3.3V    //Receive Data
	output         enet_hps_tx_en,      //3.3V    //Transmit Data Enable / Cont
	output [3:0]   enet_hps_txd,        //3.3V    //Transmit Data
	
//HPS-CAN-BUS--------------------------//2 pins  //
   input          can_0_rx,            //3.3V    //HPS only
   output         can_0_tx,            //3.3V    //HPS only 

//HPS-Trace----------------------------//10 pins //--------------------------
	//input          mictor_rstn,         //3.3V    //??????????????? not in Qsys - needed?
   output         trace_clk_mic,       //3.3V    //
   output [7:0]   trace_data,          //3.3V    //

`endif

//HPS-DDR3-400Mx40---------------------//78 pins //--------------------------
`ifdef	DDR3_HPS
   output [14:0]  ddr3_hps_a,          //SSTL15  //Address
   output [2:0]   ddr3_hps_ba,         //SSTL15  //Bank Address
   output         ddr3_hps_casn,       //SSTL15  //Column Address Strobe
   output         ddr3_hps_cke,        //SSTL15  //Clock Enable
   output         ddr3_hps_clk_n,      //SSTL15  //Diff Clock - Neg
   output         ddr3_hps_clk_p,      //SSTL15  //Diff Clock - Pos
   output         ddr3_hps_csn,        //SSTL15  //Chip Select
   output [4:0]   ddr3_hps_dm,         //SSTL15  //Data Write Mask
   inout  [39:0]  ddr3_hps_dq,         //SSTL15  //Data Bus
   inout	 [4:0]   ddr3_hps_dqs_n,      //SSTL15  //Diff Data Strobe - Neg
	inout  [4:0]   ddr3_hps_dqs_p,      //SSTL15  //Diff Data Strobe - Pos
	output         ddr3_hps_odt,        //SSTL15  //On-Die Termination Enable
	output         ddr3_hps_rasn,       //SSTL15  //Row Address Strobe
	output         ddr3_hps_resetn,     //SSTL15  //Reset
	output         ddr3_hps_wen,        //SSTL15  //Write Enable
	input          ddr3_hps_rzq,        //OCT_rzqin
	//input          ddr3_rup,          //OCT_rup
	//input          ddr3_rdn,          //OCT_rdn
`else
   //output         ddr3_hps_csn,        //SSTL15  //Chip Select
`endif


//--------------------------------------------------------------------------//
//////////////////////////////// FPGA Pins ///////////////////////////////////
//--------------------------------------------------------------------------//

	
//FPGA-GPLL-CLK------------------------//X pins
   input          clk_100m_fpga,       //2.5V    //100 MHz (2nd copy to max)
   input          clk_50m_fpga,        //2.5V    //50MHz (2nd copy to max) 
	input				clk_25m_fpga,
	input          clk_top1,            //2.5V    //156.25 MHz adjustable
   input          clk_bot1,            //1.5V    //100 MHz adjustable
//   input          clk_enet_fpga_p,     //LVDS    //125 MHz fixed

//FPGA-User-IO-------------------------//11 pins //--------------------------
	input          cpu_resetn,          //2.5V    //NIOS CPU Reset Pushbutton
	input	 [3:0]   user_dipsw_fpga,     //
	output [3:0]   user_led_fpga,       //
	input	 [1:0]   user_pb_fpga,        //

//FPGA-DDR3-400Mx32--------------------//71 pins //--------------------------
`ifdef	DDR3_FPGA
   output [14:0]  ddr3_fpga_a,         //SSTL15  //Address
   output [2:0]   ddr3_fpga_ba,        //SSTL15  //Bank Address
	output         ddr3_fpga_casn,      //SSTL15  //Column Address Strobe
	output         ddr3_fpga_cke,       //SSTL15  //Clock Enable
	output         ddr3_fpga_clk_n,     //SSTL15  //Diff Clock - Neg
	output         ddr3_fpga_clk_p,     //SSTL15  //Diff Clock - Pos
   output         ddr3_fpga_csn,       //SSTL15  //Chip Select
   output [3:0]   ddr3_fpga_dm,        //SSTL15  //Data Write Mask
   inout  [31:0]  ddr3_fpga_dq,        //SSTL15  //Data Bus
   inout  [3:0]   ddr3_fpga_dqs_n,     //SSTL15  //Diff Data Strobe - Neg
   inout  [3:0]   ddr3_fpga_dqs_p,     //SSTL15  //Diff Data Strobe - Pos
   output         ddr3_fpga_odt,       //SSTL15  //On-Die Termination Enable
   output         ddr3_fpga_rasn,      //SSTL15  //Row Address Strobe
   output         ddr3_fpga_resetn,    //SSTL15  //Reset
   output         ddr3_fpga_wen,       //SSTL15  //Write Enable
	input          ddr3_fpga_rzq,       //OCT_rzqin
`else
   output         ddr3_fpga_csn,       //SSTL15  //Chip Select
`endif
	

//FPGA-Ethernet1---10/100--------------//14 pins //--------------------------
	input			   enet1_rx_clk,        //2.5V    //Receive Data Clock
	input	[3:0]	   enet1_rx_d,          //2.5V    //Receive Data
	input			   enet1_rx_dv,         //2.5V    //Receive Data Valid
	input			   enet1_rx_error,      //2.5V    //Receive Data Error
	output         enet1_tx_clk_fb,     //2.5V    //Transmit Clock Feedback
	output [3:0]   enet1_tx_d,          //2.5V    //Transmit Data
	output         enet1_tx_en,         //2.5V    //Transmit Data Enable
	input          enet1_tx_error,      //2.5V    //Transmit Data Error
	output         enet_dual_resetn,    //2.5V    //EtherCat PHY Reset
	input			   enet2_rx_clk,        //2.5V    //Receive Data Clock
	input	[3:0]	   enet2_rx_d,          //2.5V    //Receive Data
	input			   enet2_rx_dv,         //2.5V    //Receive Data Valid
	input			   enet2_rx_error,      //2.5V    //Receive Data Error
	output         enet2_tx_clk_fb,     //2.5V    //Transmit Clock Feedback
	output [3:0]   enet2_tx_d,          //2.5V    //Transmit Data
	output         enet2_tx_en,         //2.5V    //Transmit Data Enable
	input          enet2_tx_error,      //2.5V    //Transmit Data Error
	input				enet_fpga_mdc,
	input				enet_fpga_mdio,

//SDI-XCVR-Video-----------------------//X pins  //--------------------------
`ifdef	use_SDI_XCVR_refclk_p
   	input          clk_148_p,           //LVDS    //148.5MHz Prog. SDI VCXO 
`endif
`ifdef	SDI_XCVR
	input          gxb_rx_l4_p,         //PCML    //SDI Receiver (or SMA)
	output         gxb_tx_l4_p,         //PCML    //SDI Transmitter (or SMA)
`endif

	//148.5M programmable VCXO in refclk section above
	output			sdi_clk148_dn,       //2.5V    //VCXO pump up
	output			sdi_clk148_up,       //2.5V    //VCXO pump down
	input 			sdi_fault,           //2.5V    //SDI Cable Driver Fault
	output			sdi_rsti,            //2.5V    //SDI Cable Driver Reset
	output			sdi_rx_bypass,       //2.5V    //SDI Equalizer Bypass
	output 			sdi_rx_en,           //2.5V    //SDI Equalizer Enable
	output 			sdi_tx_en,           //2.5V    //SDI Cable Driver Enable
	output 			sdi_tx_sd_hdn,       //2.5V    //SDI Cable Driver High-Def 
`ifdef	I2C_FPGA	
	inout				i2c_sda_fpga,
	inout				i2c_scl_fpga,
`endif


`ifdef	MAX_FPGA
	output	max_fpga_miso,
	input		max_fpga_mosi,
	inout		max_fpga_sck,
	inout		max_fpga_ssel,
`endif


//////////// HSMC, HSMC connect to MTLC2 //////////
//MTLC2
	inout          CAMERA_I2C_SCL,
	inout          CAMERA_I2C_SDA,
   output         CAMERA_PWDN_n,
	output  [7:0]  LCD_B,
	output         LCD_DCLK,
	output         LCD_DE,
	output         LCD_DIM,
	output         LCD_DITH,
	output  [7:0]  LCD_G,
	output         LCD_HSD,
	output         LCD_MODE,
	output         LCD_POWER_CTL,
	output         LCD_RSTB,
	output  [7:0]  LCD_R,
	output         LCD_SHLR,
	output         LCD_UPDN,
	output         LCD_VSD,
	output         LSENSOR_ADDR_SEL,
	input          LSENSOR_INT,
	inout          LSENSOR_SCL,
	inout          LSENSOR_SDA,
	output         MIPI_CS_n,
	inout          MIPI_I2C_SCL,
	inout          MIPI_I2C_SDA,
//	output         MIPI_MCLK,
	input          MIPI_PIXEL_CLK,
	input  [9:0]   MIPI_PIXEL_D,
	input          MIPI_PIXEL_HS,
	input          MIPI_PIXEL_VS,
	output         MIPI_REFCLK,
	output         MIPI_RESET_n,
	output         MPU_AD0_SDO,
	output         MPU_CS_n,
	output         MPU_FSYNC,
	input          MPU_INT,
	inout          MPU_SCL_SCLK,
	inout          MPU_SDA_SDI,
	inout          TOUCH_I2C_SCL,
	inout          TOUCH_I2C_SDA,
	input          TOUCH_INT_n, 

//PCI-Express--------------------------//X pins  //--------------------------
`ifdef	use_PCIE_XCVR_refclk_p
   input          pcie_refclk_p,       //LVDS    //PCIe Refclk -reqs OCT 
`endif
`ifdef	PCIE_XCVR               
   input  [3:0]   pcie_rx_p,           //PCML    //PCIe Receive Data-req'sOCT
   output [3:0]   pcie_tx_p,           //PCML    //PCIe Transmit Data
`endif 
//---Found multiple nets with the same name
   input			pcie_perstn_in,		// Pin W21 instance 0 
   output			pcie_perstn_out,	// Pin AG6 instance 1    
   	input				pcie_prsnt2_x1,
	input				pcie_prsnt2_x4,
	inout				pcie_smbclk,
	inout				pcie_smbdat,
	inout				pcie_waken

);

// Rev A board Ethernet reset can interrupt device configuration, to fix
// enet_dual_reset tristate as input or drive as output to 1
assign	enet_dual_resetn	=	1'b1;	
// FPGA user dipswitches drive user LEDs
//assign   user_led_fpga		=	~user_dipsw_fpga;
// Disable FPGA DDR3 
//assign   ddr3_fpga_csn		=	1'b1;	

wire	[15:0]	Read_DATA1;
wire	[15:0]	Read_DATA2;

wire	[11:0]	mCCD_DATA;
wire			   mCCD_DVAL;
wire			   mCCD_DVAL_d;
wire	[15:0]	X_Cont;
wire	[15:0]	Y_Cont;
wire	[9:0]	   X_ADDR;
wire	[31:0]	Frame_Cont;
wire			   DLY_RST_0;
wire			   DLY_RST_1;
wire			   DLY_RST_2;
wire			   DLY_RST_3;
wire			   DLY_RST_4;
wire			   Read;
reg	[11:0]	rCCD_DATA;
reg				rCCD_LVAL;
reg				rCCD_FVAL;
wire	[11:0]	sCCD_R;
wire	[11:0]	sCCD_G;
wire	[11:0]	sCCD_B;
wire			   sCCD_DVAL;
wire			   sdram_ctrl_clk;

//ltp
wire           lcd_clk;
wire	[7:0]	   lcd_r;		//	LTM Red Data 8 Bits
wire	[7:0]	   lcd_g;		//	LTM Green Data 8 Bits
wire	[7:0]	   lcd_b;		//	LTM Blue Data 8 Bits
wire           lcd_hs;
wire           lcd_vs;
wire           lcd_de;
//power on start
wire             auto_start;


wire        I2C_RELEASE ;  
wire        AUTO_FOC ; 
wire        CAMERA_I2C_SCL_MIPI ; 
wire        CAMERA_I2C_SCL_AF;
wire        CAMERA_MIPI_RELAESE ;
wire        MIPI_BRIDGE_RELEASE ; 


//=======================================================
//  Structural coding
//=======================================================
wire reset_n;
wire	ip_init_done;
wire	wrt_full_port0;
wire	wrt_full_port1;



assign LCD_MODE      = 1'b0;  //HSD/VSD mode
assign LCD_RSTB      = 1'b1;  //NO RESET
assign LCD_DIM       = 1'b1;
assign LCD_POWER_CTL = 1'b1;
assign LCD_SHLR  	   = 1'b1;
assign LCD_UPDN 	   = 1'b0;




// MTLC2 - display
assign {LCD_B,LCD_G,LCD_R} = {lcd_b, lcd_g, lcd_r};
assign LCD_DCLK            = lcd_clk;
assign LCD_HSD             = lcd_hs;
assign LCD_VSD             = lcd_vs;
assign LCD_DE              = lcd_de;

//auto start when power on
assign auto_start = ((user_pb_fpga[0])&&(DLY_RST_3)&&(!DLY_RST_4))? 1'b1:1'b0;

assign user_led_fpga[0] = ip_init_done;


always@(negedge MIPI_PIXEL_CLK)
begin
	rCCD_DATA	<=	{MIPI_PIXEL_D[9:0],2'b00};
	rCCD_LVAL	<=	MIPI_PIXEL_HS;
	rCCD_FVAL	<=	MIPI_PIXEL_VS;
end



//reset signals 
Reset_Delay			u2	(	.iCLK(clk_50m_fpga),
							.iRST(user_pb_fpga[0]),
							.oRST_0(DLY_RST_0),
							.oRST_1(DLY_RST_1),
							.oRST_2(DLY_RST_2),
							.oRST_3(DLY_RST_3), //auto-start start point
							.oRST_4(DLY_RST_4)  //auto-start end point
						);

//cmos sensor capture
CCD_Capture			u3	(	.oDATA(mCCD_DATA),
							.oDVAL(mCCD_DVAL),
							.oX_Cont(X_Cont),
							.oY_Cont(Y_Cont),
							.oFrame_Cont(Frame_Cont),
							.iDATA(rCCD_DATA),
							.iFVAL(rCCD_FVAL),
							.iLVAL(rCCD_LVAL),
							.iSTART(auto_start|1'b1),
							.iEND(1'b0),
							.iCLK(~MIPI_PIXEL_CLK),
							.iRST(DLY_RST_2)
						);
						
RAW2RGB				u4	(	.iCLK(MIPI_PIXEL_CLK),
							.iRST_n(DLY_RST_1),
							.iData(mCCD_DATA),
							.iDval(mCCD_DVAL),
							.oRed(sCCD_R),
							.oGreen(sCCD_G),
							.oBlue(sCCD_B),
							.oDval(sCCD_DVAL),
							.iMIRROR(user_dipsw_fpga[3]),
							.iX_Cont(X_Cont),
							.iY_Cont(Y_Cont)
						);	

sys_pll 			u6	(
							.inclk0(clk_50m_fpga),
							.c0(),
							.c1(),
							.c2(MIPI_REFCLK), // mipi ref clk ,20M
							.c3(lcd_clk) // cmos sensor lcd pix clock,33M
						);	

DDR3_QSYS u0 (
                     .external_clk50_clk                                 (clk_50m_fpga),                               
                     .external_reset_reset_n                             (user_pb_fpga[0]),  
		
						 // the_Write_Port0     
						   .ddr2_sodimm_write_port_iCLK_F(MIPI_PIXEL_CLK),
						   .ddr2_sodimm_write_port_iFLUSH_REQ_F(),
						   .ddr2_sodimm_write_port_iIP_INIT_DONE(ip_init_done),
						   .ddr2_sodimm_write_port_iRST_n_F(user_pb_fpga[0]),
						   .ddr2_sodimm_write_port_iWRITE_DATA_F({1'b0,sCCD_G[11:7],sCCD_B[11:2],1'b0,sCCD_G[6:2],sCCD_R[11:2]}), 
						   .ddr2_sodimm_write_port_iWRITE_F(sCCD_DVAL),
						   .oBURST_COUNT_from_the_Write_Port0(),
						   .ddr2_sodimm_write_port_oFLUSH_BUSY_F(),
						   .ddr2_sodimm_write_port_oFULL_F(wrt_full_port0),

							// the_Read_Port0   
						   .ddr2_sodimm_read_port_iCLK_F(~lcd_clk),
						   .ddr2_sodimm_read_port_iIP_INIT_DONE(ip_init_done),
						   .ddr2_sodimm_read_port_iREAD_ACK_F(Read),
						   .ddr2_sodimm_read_port_iRST_n_F(read_rstn),
						   .ddr2_sodimm_read_port_oEMPTY_F(),
						   .ddr2_sodimm_read_port_oPORT_READY_F(),
						   .ddr2_sodimm_read_port_oREAD_DATA_F({Read_DATA1,Read_DATA2}),
    
	            	   .uniphy_ddr3_status_local_init_done(ip_init_done),   //     uniphy_ddr3_status.local_init_done
		               .uniphy_ddr3_status_local_cal_success(user_led_fpga[1]), //                       .local_cal_success
		               .uniphy_ddr3_status_local_cal_fail(user_led_fpga[2]),    //                       .local_cal_fail

		               .memory_mem_a(ddr3_fpga_a),                         //                 memory.mem_a
		               .memory_mem_ba(ddr3_fpga_ba),                        //                       .mem_ba
		               .memory_mem_ck(ddr3_fpga_clk_p),                        //                       .mem_ck
		               .memory_mem_ck_n(ddr3_fpga_clk_n),                      //                       .mem_ck_n
		               .memory_mem_cke(ddr3_fpga_cke),                       //                       .mem_cke
	                	.memory_mem_cs_n(ddr3_fpga_csn),                      //                       .mem_cs_n
		               .memory_mem_dm(ddr3_fpga_dm),                        //                       .mem_dm
		               .memory_mem_ras_n(ddr3_fpga_rasn),                     //                       .mem_ras_n
		               .memory_mem_cas_n(ddr3_fpga_casn),                     //                       .mem_cas_n
		               .memory_mem_we_n(ddr3_fpga_wen),                      //                       .mem_we_n
		               .memory_mem_reset_n(ddr3_fpga_resetn),                   //                       .mem_reset_n
		               .memory_mem_dq(ddr3_fpga_dq),                        //                       .mem_dq
		               .memory_mem_dqs(ddr3_fpga_dqs_p),                       //                       .mem_dqs
		               .memory_mem_dqs_n(ddr3_fpga_dqs_n),                     //                       .mem_dqs_n
		               .memory_mem_odt(ddr3_fpga_odt),                        //                       .mem_odt
                     .oct_rzqin(ddr3_fpga_rzq)
							);

 
//prevent from read at starting because of none data in the ddr2
reg	[15:0]write_cnt;
always@(posedge ~MIPI_PIXEL_CLK)
	if (~user_pb_fpga[0])
		write_cnt <= 0;
	else if ( (sCCD_DVAL) & (write_cnt != 65536) )
		write_cnt <= write_cnt + 1;
			                  
reg	read_rstn;
	always@(posedge ~MIPI_PIXEL_CLK)
		begin
			if (~user_pb_fpga[0])
				read_rstn <= 0;
			else if (write_cnt == 512)
				read_rstn <= 1;
		end

		

//ltp controller
ltp_controller		u1	( 	.iCLK(lcd_clk),
							.iRST_n(read_rstn&DLY_RST_2),
							// sdram side
							.iREAD_DATA1(Read_DATA1),
							.iREAD_DATA2(Read_DATA2),
							.oREAD_SDRAM_EN(Read),
							// lcd side
							.oLCD_R(r_lcd_r),
							.oLCD_G(r_lcd_g),
							.oLCD_B(r_lcd_b),
							.oHD(lcd_hs),
							.oVD(lcd_vs),
							.oDEN(lcd_de)
							);
							
							
//////////////////////////////////////////////////////////
// Auto Focus
wire	[7:0]	   r_lcd_r;		//	LTM Red Data 8 Bits
wire	[7:0]	   r_lcd_g;		//	LTM Green Data 8 Bits
wire	[7:0]	   r_lcd_b;		//	LTM Blue Data 8 Bits

//------AOTO FOCUS ENABLE  --
AUTO_FOCUS_ON  vd( 
                      .CLK_50      ( clk_50m_fpga ), 
                      .I2C_RELEASE ( I2C_RELEASE ), 
                      .AUTO_FOC    ( AUTO_FOC )
                ) ;
					
						

//------AOTO FOCUS ADJ  --
FOCUS_ADJ adl(
                      .CLK_50        ( clk_50m_fpga ) , 
                      .RESET_N       ( I2C_RELEASE ), 
                      .RESET_SUB_N   ( I2C_RELEASE ), 
                      //.AUTO_FOC      ( KEY[3] & AUTO_FOC ), 
							 .AUTO_FOC      ( !area_focus_run & AUTO_FOC ), 
							 
                      .SW_Y          ( 0 ),
                      .SW_H_FREQ     ( 0 ),   
							 
                      //.SW_FUC_LINE   ( SW[3] ),   
							 .SW_FUC_LINE   (area_focus_en ),
							 
                      .SW_FUC_ALL_CEN( 0 ),
                      .VIDEO_HS      ( lcd_hs ),
                      .VIDEO_VS      ( lcd_vs ),
							 .VIDEO_DE      ( lcd_de  ), 
							 
                      .VIDEO_CLK     ( lcd_clk ),
                      .iR            ( r_lcd_r ), 
                      .iG            ( r_lcd_g ), 
                      .iB            ( r_lcd_b ), 
                      .oR            ( lcd_r ) , 
                      .oG            ( lcd_g ) , 
                      .oB            ( lcd_b ) , 
                      
                      .READY         ( READY ),
                      .SCL           ( CAMERA_I2C_SCL_AF ), 
                      .SDA           ( CAMERA_I2C_SDA )
);
							
							
							
//////////////////////////////////////////////////////////
// Auto Focus  Trigger


wire oREADY;
wire [7:0] gesture;
wire [3:0] touch_cnt;
wire touch_ready;

assign user_led_fpga[3] = area_focus_en;


i2c_touch_config i2c_touch_config(
               //Host Side
               .iCLK(clk_50m_fpga),
               .iRSTN( user_pb_fpga[0]),
               .oREADY(touch_ready),
               .INT_n(TOUCH_INT_n),
               .oREG_GESTURE(gesture),
               .oREG_TOUCH_COUNT(touch_cnt),
               //I2C Side
               .I2C_SDAT(TOUCH_I2C_SDA),
               .I2C_SCLK(TOUCH_I2C_SCL)

 ); 

 wire area_focus_run;
 wire area_focus_en;
 
auto_focus_touch_ctrl auto_focus_touch_ctrl(
.iCLK(clk_50m_fpga),
.iRST_n(user_pb_fpga[0]),

.touch_int(TOUCH_INT_n),
.gesture(gesture),
.touch_cnt(touch_cnt),
.touch_ready(touch_ready),

.area_focus_en(area_focus_en),
.area_focus_run(area_focus_run)

);





							
////////////////////////////////////////////////////
// D8M  config

// I2C configure for Camera and MIPI decoder
//------ MIPI BRIDGE & CAMERA SETTING  --  
MIPI_BRIDGE_CAMERA_Config    cfin(
                      .RESET_N           ( DLY_RST_4 ), 
                      .CLK_50            ( clk_50m_fpga ), 
                      .MIPI_I2C_SCL      ( MIPI_I2C_SCL ), 
                      .MIPI_I2C_SDA      ( MIPI_I2C_SDA ), 
                      .MIPI_I2C_RELEASE  ( MIPI_BRIDGE_RELEASE ),  
                      .CAMERA_I2C_SCL    ( CAMERA_I2C_SCL_MIPI ),
                      .CAMERA_I2C_SDA    ( CAMERA_I2C_SDA ),
                      .CAMERA_I2C_RELAESE( CAMERA_MIPI_RELAESE )
             );	
							
							
//------ MIPI BRIGE & CAMERA RESET  --
assign CAMERA_PWDN_n  = 1'b1; 
assign MIPI_CS_n      = 1'b0; 
assign MIPI_RESET_n   = DLY_RST_3 ;

//------ CAMERA MODULE I2C SWITCH  --
assign I2C_RELEASE    = CAMERA_MIPI_RELAESE & MIPI_BRIDGE_RELEASE; 
assign CAMERA_I2C_SCL = ( I2C_RELEASE  )?  CAMERA_I2C_SCL_AF  : CAMERA_I2C_SCL_MIPI ;   


//------VS FREQUENCY TEST = 60HZ --
							
FpsMonitor uFps( 
	/*input					  */     .clk50    ( clk_50m_fpga ),
	/*input     			  */     .vs       ( MIPI_PIXEL_VS ),
	
	/*output reg [7:0]		*/    .fps      ( ),
	/*output reg [6:0]		*/    .hex_fps_h(  ),
	/*output reg [6:0]		*/    .hex_fps_l(  )

             );	

							
endmodule











