	component DDR3_QSYS is
		port (
			external_clk50_clk                   : in    std_logic                     := 'X';             -- clk
			external_reset_reset_n               : in    std_logic                     := 'X';             -- reset_n
			ddr2_sodimm_write_port_iRST_n_F      : in    std_logic                     := 'X';             -- iRST_n_F
			ddr2_sodimm_write_port_iCLK_F        : in    std_logic                     := 'X';             -- iCLK_F
			ddr2_sodimm_write_port_iWRITE_F      : in    std_logic                     := 'X';             -- iWRITE_F
			ddr2_sodimm_write_port_iWRITE_DATA_F : in    std_logic_vector(31 downto 0) := (others => 'X'); -- iWRITE_DATA_F
			ddr2_sodimm_write_port_oFULL_F       : out   std_logic;                                        -- oFULL_F
			ddr2_sodimm_write_port_iFLUSH_REQ_F  : in    std_logic                     := 'X';             -- iFLUSH_REQ_F
			ddr2_sodimm_write_port_oFLUSH_BUSY_F : out   std_logic;                                        -- oFLUSH_BUSY_F
			ddr2_sodimm_write_port_iIP_INIT_DONE : in    std_logic                     := 'X';             -- iIP_INIT_DONE
			ddr2_sodimm_write_port_c_state_flush : out   std_logic_vector(4 downto 0);                     -- c_state_flush
			ddr2_sodimm_write_port_wrusedw       : out   std_logic_vector(8 downto 0);                     -- wrusedw
			ddr2_sodimm_write_port_c_state       : out   std_logic_vector(3 downto 0);                     -- c_state
			ddr2_sodimm_read_port_iRST_n_F       : in    std_logic                     := 'X';             -- iRST_n_F
			ddr2_sodimm_read_port_iCLK_F         : in    std_logic                     := 'X';             -- iCLK_F
			ddr2_sodimm_read_port_iREAD_ACK_F    : in    std_logic                     := 'X';             -- iREAD_ACK_F
			ddr2_sodimm_read_port_oREAD_DATA_F   : out   std_logic_vector(31 downto 0);                    -- oREAD_DATA_F
			ddr2_sodimm_read_port_oEMPTY_F       : out   std_logic;                                        -- oEMPTY_F
			ddr2_sodimm_read_port_oPORT_READY_F  : out   std_logic;                                        -- oPORT_READY_F
			ddr2_sodimm_read_port_iIP_INIT_DONE  : in    std_logic                     := 'X';             -- iIP_INIT_DONE
			ddr2_sodimm_read_port_c_state        : out   std_logic_vector(3 downto 0);                     -- c_state
			ddr2_sodimm_read_port_error          : out   std_logic;                                        -- error
			memory_mem_a                         : out   std_logic_vector(14 downto 0);                    -- mem_a
			memory_mem_ba                        : out   std_logic_vector(2 downto 0);                     -- mem_ba
			memory_mem_ck                        : out   std_logic_vector(0 downto 0);                     -- mem_ck
			memory_mem_ck_n                      : out   std_logic_vector(0 downto 0);                     -- mem_ck_n
			memory_mem_cke                       : out   std_logic_vector(0 downto 0);                     -- mem_cke
			memory_mem_cs_n                      : out   std_logic_vector(0 downto 0);                     -- mem_cs_n
			memory_mem_dm                        : out   std_logic_vector(3 downto 0);                     -- mem_dm
			memory_mem_ras_n                     : out   std_logic_vector(0 downto 0);                     -- mem_ras_n
			memory_mem_cas_n                     : out   std_logic_vector(0 downto 0);                     -- mem_cas_n
			memory_mem_we_n                      : out   std_logic_vector(0 downto 0);                     -- mem_we_n
			memory_mem_reset_n                   : out   std_logic;                                        -- mem_reset_n
			memory_mem_dq                        : inout std_logic_vector(31 downto 0) := (others => 'X'); -- mem_dq
			memory_mem_dqs                       : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs
			memory_mem_dqs_n                     : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs_n
			memory_mem_odt                       : out   std_logic_vector(0 downto 0);                     -- mem_odt
			oct_rzqin                            : in    std_logic                     := 'X';             -- rzqin
			uniphy_ddr3_status_local_init_done   : out   std_logic;                                        -- local_init_done
			uniphy_ddr3_status_local_cal_success : out   std_logic;                                        -- local_cal_success
			uniphy_ddr3_status_local_cal_fail    : out   std_logic                                         -- local_cal_fail
		);
	end component DDR3_QSYS;

	u0 : component DDR3_QSYS
		port map (
			external_clk50_clk                   => CONNECTED_TO_external_clk50_clk,                   --         external_clk50.clk
			external_reset_reset_n               => CONNECTED_TO_external_reset_reset_n,               --         external_reset.reset_n
			ddr2_sodimm_write_port_iRST_n_F      => CONNECTED_TO_ddr2_sodimm_write_port_iRST_n_F,      -- ddr2_sodimm_write_port.iRST_n_F
			ddr2_sodimm_write_port_iCLK_F        => CONNECTED_TO_ddr2_sodimm_write_port_iCLK_F,        --                       .iCLK_F
			ddr2_sodimm_write_port_iWRITE_F      => CONNECTED_TO_ddr2_sodimm_write_port_iWRITE_F,      --                       .iWRITE_F
			ddr2_sodimm_write_port_iWRITE_DATA_F => CONNECTED_TO_ddr2_sodimm_write_port_iWRITE_DATA_F, --                       .iWRITE_DATA_F
			ddr2_sodimm_write_port_oFULL_F       => CONNECTED_TO_ddr2_sodimm_write_port_oFULL_F,       --                       .oFULL_F
			ddr2_sodimm_write_port_iFLUSH_REQ_F  => CONNECTED_TO_ddr2_sodimm_write_port_iFLUSH_REQ_F,  --                       .iFLUSH_REQ_F
			ddr2_sodimm_write_port_oFLUSH_BUSY_F => CONNECTED_TO_ddr2_sodimm_write_port_oFLUSH_BUSY_F, --                       .oFLUSH_BUSY_F
			ddr2_sodimm_write_port_iIP_INIT_DONE => CONNECTED_TO_ddr2_sodimm_write_port_iIP_INIT_DONE, --                       .iIP_INIT_DONE
			ddr2_sodimm_write_port_c_state_flush => CONNECTED_TO_ddr2_sodimm_write_port_c_state_flush, --                       .c_state_flush
			ddr2_sodimm_write_port_wrusedw       => CONNECTED_TO_ddr2_sodimm_write_port_wrusedw,       --                       .wrusedw
			ddr2_sodimm_write_port_c_state       => CONNECTED_TO_ddr2_sodimm_write_port_c_state,       --                       .c_state
			ddr2_sodimm_read_port_iRST_n_F       => CONNECTED_TO_ddr2_sodimm_read_port_iRST_n_F,       --  ddr2_sodimm_read_port.iRST_n_F
			ddr2_sodimm_read_port_iCLK_F         => CONNECTED_TO_ddr2_sodimm_read_port_iCLK_F,         --                       .iCLK_F
			ddr2_sodimm_read_port_iREAD_ACK_F    => CONNECTED_TO_ddr2_sodimm_read_port_iREAD_ACK_F,    --                       .iREAD_ACK_F
			ddr2_sodimm_read_port_oREAD_DATA_F   => CONNECTED_TO_ddr2_sodimm_read_port_oREAD_DATA_F,   --                       .oREAD_DATA_F
			ddr2_sodimm_read_port_oEMPTY_F       => CONNECTED_TO_ddr2_sodimm_read_port_oEMPTY_F,       --                       .oEMPTY_F
			ddr2_sodimm_read_port_oPORT_READY_F  => CONNECTED_TO_ddr2_sodimm_read_port_oPORT_READY_F,  --                       .oPORT_READY_F
			ddr2_sodimm_read_port_iIP_INIT_DONE  => CONNECTED_TO_ddr2_sodimm_read_port_iIP_INIT_DONE,  --                       .iIP_INIT_DONE
			ddr2_sodimm_read_port_c_state        => CONNECTED_TO_ddr2_sodimm_read_port_c_state,        --                       .c_state
			ddr2_sodimm_read_port_error          => CONNECTED_TO_ddr2_sodimm_read_port_error,          --                       .error
			memory_mem_a                         => CONNECTED_TO_memory_mem_a,                         --                 memory.mem_a
			memory_mem_ba                        => CONNECTED_TO_memory_mem_ba,                        --                       .mem_ba
			memory_mem_ck                        => CONNECTED_TO_memory_mem_ck,                        --                       .mem_ck
			memory_mem_ck_n                      => CONNECTED_TO_memory_mem_ck_n,                      --                       .mem_ck_n
			memory_mem_cke                       => CONNECTED_TO_memory_mem_cke,                       --                       .mem_cke
			memory_mem_cs_n                      => CONNECTED_TO_memory_mem_cs_n,                      --                       .mem_cs_n
			memory_mem_dm                        => CONNECTED_TO_memory_mem_dm,                        --                       .mem_dm
			memory_mem_ras_n                     => CONNECTED_TO_memory_mem_ras_n,                     --                       .mem_ras_n
			memory_mem_cas_n                     => CONNECTED_TO_memory_mem_cas_n,                     --                       .mem_cas_n
			memory_mem_we_n                      => CONNECTED_TO_memory_mem_we_n,                      --                       .mem_we_n
			memory_mem_reset_n                   => CONNECTED_TO_memory_mem_reset_n,                   --                       .mem_reset_n
			memory_mem_dq                        => CONNECTED_TO_memory_mem_dq,                        --                       .mem_dq
			memory_mem_dqs                       => CONNECTED_TO_memory_mem_dqs,                       --                       .mem_dqs
			memory_mem_dqs_n                     => CONNECTED_TO_memory_mem_dqs_n,                     --                       .mem_dqs_n
			memory_mem_odt                       => CONNECTED_TO_memory_mem_odt,                       --                       .mem_odt
			oct_rzqin                            => CONNECTED_TO_oct_rzqin,                            --                    oct.rzqin
			uniphy_ddr3_status_local_init_done   => CONNECTED_TO_uniphy_ddr3_status_local_init_done,   --     uniphy_ddr3_status.local_init_done
			uniphy_ddr3_status_local_cal_success => CONNECTED_TO_uniphy_ddr3_status_local_cal_success, --                       .local_cal_success
			uniphy_ddr3_status_local_cal_fail    => CONNECTED_TO_uniphy_ddr3_status_local_cal_fail     --                       .local_cal_fail
		);

