//--------------------------------------------------------------------------//
// Title:       Painter.v                                                //
// Rev:         Rev 0                                                       //
// Created:     June 13, 2016                                               //
//--------------------------------------------------------------------------//
// Description: Cyclone V SX SoC pinout and IO Standard example design      //              					                        //
//--------------------------------------------------------------------------//
// Revision History:                                                        //
// Rev 0:       1st cut                                                      //
//----------------------------------------------------------------------------
//------ 1 ------- 2 ------- 3 ------- 4 ------- 5 ------- 6 ------- 7 ------7
//------ 0 ------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------- 0 ------8
//----------------------------------------------------------------------------
//Copyright 2012 Altera Corporation. All rights reserved.  Altera products  
//are protected under numerous U.S. and foreign patents, maskwork rights,     
//copyrights and other intellectual property laws.                            
//                                                                            
//This reference design file, and your use thereof, is subject to and         
//governed by the terms and conditions of the applicable Altera Reference     
//Design License Agreement.  By using this reference design file, you         
//indicate your acceptance of such terms and conditions between you and       
//Altera Corporation.  In the event that you do not agree with such terms and 
//conditions, you may not use the reference design file. Please promptly      
//destroy any copies you have made.                                           
//                                                                            
//This reference design file being provided on an "as-is" basis and as an                                             
//accommodation and therefore all warranties, representations or guarantees   
//of any kind (whether express, implied or statutory) including, without      
//limitation, warranties of merchantability, non-infringement, or fitness for 
//a particular purpose, are specifically disclaimed.  By making this          
//reference design file available, Altera expressly does not recommend,       
//suggest or require that this reference design file be used in combination   
//with any other product not provided by Altera.                              
//                                                                            



//`define		HPS
`define	DDR3_FPGA
//`define	DDR3_HPS
//`define	I2C_FPGA
//`define	MAX_FPGA

//`define	HSMA_XCVR      
//`define	HSMA_LVDS
//`define	HSMA_PARALLEL 
//`define	PCIE_XCVR
//`define	SDI_XCVR

module G_sensor (
//--------------------------------------------------------------------------//
/*
//User-IO------------------------------//X pins  //--------------------------
	output [3:0]   user_led_fpga,       
	
//GPLL-CLK-----------------------------//X pins
   input          clk_100m_fpga,       //2.5V    //100 MHz (2nd copy to max)
   input          clk_50m_fpga,        //2.5V    //50MHz (2nd copy to max) 

	input          clk_top1,            //2.5V    //156.25 MHz adjustable
   input          clk_bot1,            //1.5V    //100 MHz ajustable

	  output         ddr3_fpga_csn,       //SSTL15  //Chip Select
	input          cpu_resetn          //2.5V    //NIOS CPU Reset Pushbutton
*/
//--------------------------------------------------------------------------//
//////////////////// Hard Processor System (HPS) pins ////////////////////////
//--------------------------------------------------------------------------//

`ifdef	HPS
//HPS-CLK-INPUT------------------------//2 pins   //--------------------------
   //input          clk_osc1,            //3.3V     //Not for instantiation
   //input          clk_osc2,            //3.3V     //Not for instantiation

//HPS-Reset----------------------------//2 pins  //--------------------------
   //inout          mictor_rstn,         //3.3V    //Cold Reset 
   //input          hps_resetn,          //3.3V    //Warm Reset 

//HPS-User-IO--------------------------//X pins  //--------------------------
   //input  [3:0]   user_dipsw_hps,      //1.5V
   //output [3:0]   user_led_hps,        //3.3V
   //input  [1:0]   user_pb_hps,         //1.5V

//HPS-UART----------------------------//2 pins   //--------------------------
   input          uart_rx,            //3.3V LV  //UART Receive
   output         uart_tx,            //3.3V     //UART Transmit


//HPS-I2C------------------------------//2 pins  //--------------------------
	inout          i2c_scl_hps,         //3.3V    //HPS I2C Clock output
	inout          i2c_sda_hps,         //3.3V    //HPS I2C Data Input/Output
	
//HPS-SPI-Bus--------------------------//4 pins  //--------------------------
	output         spi_csn,             //3.3V    //Slave Sel 0 - LTC Analog
	input          spi_miso,            //3.3V    //Master Input
	output         spi_mosi,            //3.3V    //Master Output 
	output         spi_sck,             //3.3V    //Clock Output 

//HPS-QSPI-Flash-----------------------//6 pins  //--------------------------
	output         qspi_clk,            //3.3V    //Clock
	inout [3:0]    qspi_io,             //3.3V    //Data
	output         qspi_ss0,            //3.3V    //Select
	
//HPS-SD-Card-Flash--------------------//7 pins  //--------------------------
   output         sd_clk,              //3.3V    //
	inout          sd_cmd,              //3.3V    //
	output         sd_pwren,            //3.3V    //
   //inout  [3:0]   sd_dat,              //3.3V    //???????????????  should only be (3:0) ????????
   inout  [7:0]   sd_dat,              //3.3V    //???????????????  should only be (3:0) ????????

//HPS-USB-OTG-------------------------//19 pins  //--------------------------
	input          usb_clk,            //3.3V     //Clock
	inout  [7:0]   usb_data,           //3.3V     //
	input          usb_nxt,            //3.3V     //
	input          usb_dir,            //3.3V     //
	output         usb_stp,            //3.3V     //
	input          usb_empty,  
	input          usb_full,    
	output         usb_oen,    
	output         usb_rdn,       
	output         usb_resetn,
	output         usb_scl,       
	inout          usb_sda,       
	output         usb_wrn,
	

//HPS-Ethernet----10/100/1000----------//14 pins //--------------------------
	output         enet_hps_gtx_clk,    //3.3V    //Gb Ethernet Clock
	//input			   enet_hps_intn,       //3.3V    //Placed on HPS GPIO
	output         enet_hps_mdc,        //3.3V    //MDIO Clock (TR=0)
	inout          enet_hps_mdio,       //3.3V    //MDIO Data (TR=0)
	input			   enet_hps_rx_clk,     //3.3V    //Receive Data
	input			   enet_hps_rx_dv,      //3.3V    //Receive Data Valid / Cont
	input	[3:0]	   enet_hps_rxd,        //3.3V    //Receive Data
	output         enet_hps_tx_en,      //3.3V    //Transmit Data Enable / Cont
	output [3:0]   enet_hps_txd,        //3.3V    //Transmit Data
	
//HPS-CAN-BUS--------------------------//2 pins  //
   input          can_0_rx,            //3.3V    //HPS only
   output         can_0_tx,            //3.3V    //HPS only 

//HPS-Trace----------------------------//10 pins //--------------------------
	//input          mictor_rstn,         //3.3V    //??????????????? not in Qsys - needed?
   output         trace_clk_mic,       //3.3V    //
   output [7:0]   trace_data,          //3.3V    //

`endif

//HPS-DDR3-400Mx40---------------------//78 pins //--------------------------
`ifdef	DDR3_HPS
   output [14:0]  ddr3_hps_a,          //SSTL15  //Address
   output [2:0]   ddr3_hps_ba,         //SSTL15  //Bank Address
   output         ddr3_hps_casn,       //SSTL15  //Column Address Strobe
   output         ddr3_hps_cke,        //SSTL15  //Clock Enable
   output         ddr3_hps_clk_n,      //SSTL15  //Diff Clock - Neg
   output         ddr3_hps_clk_p,      //SSTL15  //Diff Clock - Pos
   output         ddr3_hps_csn,        //SSTL15  //Chip Select
   output [4:0]   ddr3_hps_dm,         //SSTL15  //Data Write Mask
   inout  [39:0]  ddr3_hps_dq,         //SSTL15  //Data Bus
   inout	 [4:0]   ddr3_hps_dqs_n,      //SSTL15  //Diff Data Strobe - Neg
	inout  [4:0]   ddr3_hps_dqs_p,      //SSTL15  //Diff Data Strobe - Pos
	output         ddr3_hps_odt,        //SSTL15  //On-Die Termination Enable
	output         ddr3_hps_rasn,       //SSTL15  //Row Address Strobe
	output         ddr3_hps_resetn,     //SSTL15  //Reset
	output         ddr3_hps_wen,        //SSTL15  //Write Enable
	input          ddr3_hps_rzq,        //OCT_rzqin
	//input          ddr3_rup,          //OCT_rup
	//input          ddr3_rdn,          //OCT_rdn
`else
   //output         ddr3_hps_csn,        //SSTL15  //Chip Select
`endif


//--------------------------------------------------------------------------//
//////////////////////////////// FPGA Pins ///////////////////////////////////
//--------------------------------------------------------------------------//

	
//FPGA-GPLL-CLK------------------------//X pins
   input          clk_100m_fpga,       //2.5V    //100 MHz (2nd copy to max)
   input          clk_50m_fpga,        //2.5V    //50MHz (2nd copy to max) 
	input				clk_25m_fpga,
	input          clk_top1,            //2.5V    //156.25 MHz adjustable
   input          clk_bot1,            //1.5V    //100 MHz adjustable
//   input          clk_enet_fpga_p,     //LVDS    //125 MHz fixed

//FPGA-User-IO-------------------------//11 pins //--------------------------
	input          cpu_resetn,          //2.5V    //NIOS CPU Reset Pushbutton
	input	 [3:0]   user_dipsw_fpga,     //
	output [3:0]   user_led_fpga,       //
	input	 [1:0]   user_pb_fpga,        //

//FPGA-DDR3-400Mx32--------------------//71 pins //--------------------------
`ifdef	DDR3_FPGA
   output [14:0]  ddr3_fpga_a,         //SSTL15  //Address
   output [2:0]   ddr3_fpga_ba,        //SSTL15  //Bank Address
	output         ddr3_fpga_casn,      //SSTL15  //Column Address Strobe
	output         ddr3_fpga_cke,       //SSTL15  //Clock Enable
	output         ddr3_fpga_clk_n,     //SSTL15  //Diff Clock - Neg
	output         ddr3_fpga_clk_p,     //SSTL15  //Diff Clock - Pos
   output         ddr3_fpga_csn,       //SSTL15  //Chip Select
   output [3:0]   ddr3_fpga_dm,        //SSTL15  //Data Write Mask
   inout  [31:0]  ddr3_fpga_dq,        //SSTL15  //Data Bus
   inout  [3:0]   ddr3_fpga_dqs_n,     //SSTL15  //Diff Data Strobe - Neg
   inout  [3:0]   ddr3_fpga_dqs_p,     //SSTL15  //Diff Data Strobe - Pos
   output         ddr3_fpga_odt,       //SSTL15  //On-Die Termination Enable
   output         ddr3_fpga_rasn,      //SSTL15  //Row Address Strobe
   output         ddr3_fpga_resetn,    //SSTL15  //Reset
   output         ddr3_fpga_wen,       //SSTL15  //Write Enable
	input          ddr3_fpga_rzq,       //OCT_rzqin
`else
   output         ddr3_fpga_csn,       //SSTL15  //Chip Select
`endif
	

//FPGA-Ethernet1---10/100--------------//14 pins //--------------------------
	input			   enet1_rx_clk,        //2.5V    //Receive Data Clock
	input	[3:0]	   enet1_rx_d,          //2.5V    //Receive Data
	input			   enet1_rx_dv,         //2.5V    //Receive Data Valid
	input			   enet1_rx_error,      //2.5V    //Receive Data Error
	output         enet1_tx_clk_fb,     //2.5V    //Transmit Clock Feedback
	output [3:0]   enet1_tx_d,          //2.5V    //Transmit Data
	output         enet1_tx_en,         //2.5V    //Transmit Data Enable
	input          enet1_tx_error,      //2.5V    //Transmit Data Error
	output         enet_dual_resetn,    //2.5V    //EtherCat PHY Reset
	input			   enet2_rx_clk,        //2.5V    //Receive Data Clock
	input	[3:0]	   enet2_rx_d,          //2.5V    //Receive Data
	input			   enet2_rx_dv,         //2.5V    //Receive Data Valid
	input			   enet2_rx_error,      //2.5V    //Receive Data Error
	output         enet2_tx_clk_fb,     //2.5V    //Transmit Clock Feedback
	output [3:0]   enet2_tx_d,          //2.5V    //Transmit Data
	output         enet2_tx_en,         //2.5V    //Transmit Data Enable
	input          enet2_tx_error,      //2.5V    //Transmit Data Error
	input				enet_fpga_mdc,
	input				enet_fpga_mdio,

//SDI-XCVR-Video-----------------------//X pins  //--------------------------
`ifdef	use_SDI_XCVR_refclk_p
   	input          clk_148_p,           //LVDS    //148.5MHz Prog. SDI VCXO 
`endif
`ifdef	SDI_XCVR
	input          gxb_rx_l4_p,         //PCML    //SDI Receiver (or SMA)
	output         gxb_tx_l4_p,         //PCML    //SDI Transmitter (or SMA)
`endif

	//148.5M programmable VCXO in refclk section above
	output			sdi_clk148_dn,       //2.5V    //VCXO pump up
	output			sdi_clk148_up,       //2.5V    //VCXO pump down
	input 			sdi_fault,           //2.5V    //SDI Cable Driver Fault
	output			sdi_rsti,            //2.5V    //SDI Cable Driver Reset
	output			sdi_rx_bypass,       //2.5V    //SDI Equalizer Bypass
	output 			sdi_rx_en,           //2.5V    //SDI Equalizer Enable
	output 			sdi_tx_en,           //2.5V    //SDI Cable Driver Enable
	output 			sdi_tx_sd_hdn,       //2.5V    //SDI Cable Driver High-Def 
`ifdef	I2C_FPGA	
	inout				i2c_sda_fpga,
	inout				i2c_scl_fpga,
`endif


`ifdef	MAX_FPGA
	output	max_fpga_miso,
	input		max_fpga_mosi,
	inout		max_fpga_sck,
	inout		max_fpga_ssel,
`endif


//////////// HSMC, HSMC connect to MTLC2 //////////
//MTLC2
	inout          Painter_I2C_SCL,
	inout          Painter_I2C_SDA,
   output         Painter_PWDN_n,
	output  [7:0]  LCD_B,
	output         LCD_DCLK,
	output         LCD_DE,
	output         LCD_DIM,
	output         LCD_DITH,
	output  [7:0]  LCD_G,
	output         LCD_HSD,
	output         LCD_MODE,
	output         LCD_POWER_CTL,
	output         LCD_RSTB,
	output  [7:0]  LCD_R,
	output         LCD_SHLR,
	output         LCD_UPDN,
	output         LCD_VSD,
	output         LSENSOR_ADDR_SEL,
	input          LSENSOR_INT,
	output         LSENSOR_SCL,
	inout          LSENSOR_SDA,
	output         MIPI_CS_n,
	inout          MIPI_I2C_SCL,
	inout          MIPI_I2C_SDA,
//	output         MIPI_MCLK,
	input          MIPI_PIXEL_CLK,
	input  [9:0]   MIPI_PIXEL_D,
	input          MIPI_PIXEL_HS,
	input          MIPI_PIXEL_VS,
	output         MIPI_REFCLK,
	output         MIPI_RESET_n,
	output         MPU_AD0_SDO,
	output         MPU_CS_n,
	output         MPU_FSYNC,
	input          MPU_INT,
	output         MPU_SCL_SCLK,
	inout          MPU_SDA_SDI,
	inout          TOUCH_I2C_SCL,
	inout          TOUCH_I2C_SDA,
	input          TOUCH_INT_n, 

//PCI-Express--------------------------//X pins  //--------------------------
`ifdef	use_PCIE_XCVR_refclk_p
   input          pcie_refclk_p,       //LVDS    //PCIe Refclk -reqs OCT 
`endif
`ifdef	PCIE_XCVR               
   input  [3:0]   pcie_rx_p,           //PCML    //PCIe Receive Data-req'sOCT
   output [3:0]   pcie_tx_p,           //PCML    //PCIe Transmit Data
`endif 
//---Found multiple nets with the same name
   input			pcie_perstn_in,		// Pin W21 instance 0 
   output			pcie_perstn_out,	// Pin AG6 instance 1    
   	input				pcie_prsnt2_x1,
	input				pcie_prsnt2_x4,
	inout				pcie_smbclk,
	inout				pcie_smbdat,
	inout				pcie_waken

);

// Rev A board Ethernet reset can interrupt device configuration, to fix
// enet_dual_reset tristate as input or drive as output to 1
assign	enet_dual_resetn	=	1'b1;	
// FPGA user dipswitches drive user LEDs
//assign   user_led_fpga		=	~user_dipsw_fpga;
// Disable FPGA DDR3 
//assign   ddr3_fpga_csn		=	1'b1;	

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire [7:0] video_r;
wire [7:0] video_g;
wire [7:0] video_b;
wire       video_clk;
wire       video_hs;
wire       video_vs;

wire       reset_n;
//=======================================================
//  Structural coding
//=======================================================
assign LCD_MODE = 1'b0;  //HSD/VSD mode
assign LCD_RSTB = 1'b1; //NO RESET
assign LCD_DIM  = 1'b1;
assign LCD_POWER_CTL = 1'b1;
assign LCD_SHLR  	= 1'b1;
assign LCD_UPDN 	= 1'b0;


 vga_pll vga_pll_inst(
				.rst(1'b0),
				.refclk(clk_50m_fpga),
				.outclk_0(video_clk),
				.locked(reset_n)
				);

C5SOC_Qsys u0(
		.clk_clk                                       (clk_50m_fpga),                            // clk.clk
		.reset_reset_n                                 (1'b1),                                    // reset.reset_n
		
		.alt_vip_itc_0_clocked_video_vid_clk           (video_clk),                      			// alt_vip_itc_0_clocked_video.vid_clk
		.alt_vip_itc_0_clocked_video_vid_data          ({video_r, video_g, video_b}),             //                            .vid_data
		.alt_vip_itc_0_clocked_video_underflow         (),                    							//                            .underflow
		.alt_vip_itc_0_clocked_video_vid_datavalid     (),                								//                            .vid_datavalid
		.alt_vip_itc_0_clocked_video_vid_v_sync        (video_vs),                   					//                            .vid_v_sync
		.alt_vip_itc_0_clocked_video_vid_h_sync        (video_hs),                   					//                            .vid_h_sync
		.alt_vip_itc_0_clocked_video_vid_f             (),                        						//                            .vid_f
		.alt_vip_itc_0_clocked_video_vid_h             (),                        						//                            .vid_h
		.alt_vip_itc_0_clocked_video_vid_v             (),                        						//                            .vid_v
		
		
		.mem_if_ddr3_emif_0_status_local_init_done     (user_led_fpga[0]),                			// mem_if_ddr3_emif_0_status.local_init_done
		.mem_if_ddr3_emif_0_status_local_cal_success   (user_led_fpga[1]),              				//                          .local_cal_success
		.mem_if_ddr3_emif_0_status_local_cal_fail      (user_led_fpga[2]),                 			//                          .local_cal_fail
		
		.memory_mem_a                                  (ddr3_fpga_a),                             //  memory.mem_a
		.memory_mem_ba                                 (ddr3_fpga_ba),                            //        .mem_ba
		.memory_mem_ck                                 (ddr3_fpga_clk_p),                         //        .mem_ck
		.memory_mem_ck_n                               (ddr3_fpga_clk_n),                         //        .mem_ck_n
		.memory_mem_cke                                (ddr3_fpga_cke),                           //        .mem_cke
		.memory_mem_cs_n                               (ddr3_fpga_csn),                           //        .mem_cs_n
		.memory_mem_dm                                 (ddr3_fpga_dm),                            //        .mem_dm
		.memory_mem_ras_n                              (ddr3_fpga_rasn),                          //        .mem_ras_n
		.memory_mem_cas_n                              (ddr3_fpga_casn),                          //        .mem_cas_n
		.memory_mem_we_n                               (ddr3_fpga_wen),                           //        .mem_we_n
		.memory_mem_reset_n                            (ddr3_fpga_resetn),                        //        .mem_reset_n
		.memory_mem_dq                                 (ddr3_fpga_dq),                            //        .mem_dq
		.memory_mem_dqs                                (ddr3_fpga_dqs_p),                         //        .mem_dqs
		.memory_mem_dqs_n                              (ddr3_fpga_dqs_n),                         //        .mem_dqs_n
		.memory_mem_odt                                (ddr3_fpga_odt),                           //        .mem_odt
		.oct_rzqin                                     (ddr3_fpga_rzq),                           //     oct.rzqin
  
      .touch_int_n_external_connection_export       (TOUCH_INT_n),                 				// lcd_touch_int_external_connection.export
      .touch_i2c_opencores_export_scl_pad_io        (TOUCH_I2C_SCL),                   			// lcd_touch_i2c_conduit_start.scl_pad_io
      .touch_i2c_opencores_export_sda_pad_io        (TOUCH_I2C_SDA),                    			//                            .sda_pad_io

		
	
		
		.key_external_connection_export                (user_pb_fpga),                           	// key_external_connection.export
		.sw_external_connection_export                 (user_dipsw_fpga),                         // sw_external_connection.export
		.led_external_connection_export                (),                           					// led_external_connection.export
	
	  .mpu_i2c_opencores_export_scl_pad_io                      (MPU_SCL_SCLK ),                      //          mpu_i2c_opencores_export.scl_pad_io
	  .mpu_i2c_opencores_export_sda_pad_io                      (MPU_SDA_SDI ),                      //                                  .sda_pad_io
	  .mpu_int_external_connection_export                       (MPU_INT ),                       //       mpu_int_external_connection.export
	  .light_i2c_opencores_export_scl_pad_io                    (LSENSOR_SCL ),                    //        light_i2c_opencores_export.scl_pad_io
	  .light_i2c_opencores_export_sda_pad_io                    (LSENSOR_SDA ),                    //                                  .sda_pad_io
	  .light_int_external_connection_export                     (LSENSOR_INT )                      //     light_int_external_connection.export

	);

///////////////////////////////////////////

// MTL - display
assign {LCD_R,LCD_G,LCD_B} = {video_r, video_g, video_b};
assign LCD_DCLK = video_clk;
assign LCD_HSD = ~video_hs;
assign LCD_VSD = ~video_vs;


// mtlc2: light sensor	
assign LSENSOR_ADDR_SEL = 1'b0;


// mtlc2: mpu9250
assign MPU_AD0_SDO = 1'b0;
assign MPU_CS_n = 1'b1; // pull-high for I2C
assign MPU_FSYNC = 1'b0; 
endmodule











						



 














